
input_select:
  trash_pickup_day:
    name: Select Trash Pickup Day
    options:
      - Monday
      - Tuesday
      - Wednesday
      - Thursday
      - Friday
      - Saturday
      - Sunday
    icon: mdi:trash-can
  recycle_pickup_week:
    name: Select Recycle Pickup Week
    options:
      - Even Weeks
      - Odd Weeks
    icon: mdi:recycle
input_boolean:
  trash_reminders:
    name: Trash Reminders
    icon: mdi:trash-can
    
sensor:
###############################################################################
# Sensor to hold info about current week is an odd week or an even week of the year
###############################################################################
  - platform: template
    sensors:
      weeks_since_epoch:
        value_template: >-
          {% set readDateToTriggerUpdates = states('sensor.date') %}
          {% set firstUtcSunday = 259200 %}
          {% set tzOffset = as_timestamp(now()) | timestamp_custom('%z', true)%}
          {% set tzOffestEpoch = (tzOffset[:-2] | int) * 60 * 60 %}
          {%- if tzOffestEpoch > 0 -%}
            {% set tzOffestEpoch = tzOffestEpoch + (tzOffset[-2:] | int) * 60 %}
          {%- else -%}
            {% set tzOffestEpoch = tzOffestEpoch - (tzOffset[-2:] | int) * 60 %}
          {%- endif -%}
          {% set firstSunday = firstUtcSunday - tzOffestEpoch %}
          {% set secondsSinceFirstSunday = (as_timestamp(now()) - firstSunday) %}
          {% set weeksSinceFirstSunday = (secondsSinceFirstSunday / 604800) | int  %}
          {{ weeksSinceFirstSunday }}
  - platform: template
    sensors:
      current_week:
        value_template: >-
          {%- if (states('sensor.weeks_since_epoch') | int) % 2 == 0 -%}
            Even Week
          {%- else -%}
            Odd Week
          {%- endif -%}
###############################################################################
# Trash  - Pickup schedule is EVERY week.
# Set the day to a day before the actual day leaving time for reminders
###############################################################################
  - platform: template
    sensors:
      trash_day:
        friendly_name: Trash Day
        value_template: >-
          {% set readDateToTriggerUpdates = states('sensor.date') %}
          {%- set pickupDay = states('input_select.trash_pickup_day') | lower -%}
          {%- if as_timestamp(now()) | timestamp_custom('%A', true) | lower == pickupDay -%}
            yes
          {%- else -%}
            no
          {%- endif -%}
  - platform: template
    sensors:
      trash_day_tomorrow:
        friendly_name: Trash Day Tomorrow
        value_template: >-
          {% set readDateToTriggerUpdates = states('sensor.date') %}
          {%- set pickupDay = states('input_select.trash_pickup_day') | lower -%}
          {%- if (as_timestamp(now()) + 86400) | timestamp_custom('%A', true) | lower == pickupDay -%}
            yes
          {%- else -%}
            no
          {%- endif -%}
###############################################################################
# Recycle - Pickup schedule is every other week.
# Set the day to a day before the actual day leaving time for reminders
###############################################################################
  - platform: template
    sensors:
      recycle_week:
        friendly_name: Recycle Week
        value_template: >-
          {% if states('input_select.recycle_pickup_week') | lower == "even weeks" %}
            {% set evenWeekPickup = true %}
          {% else %}
            {% set evenWeekPickup = false %}
          {% endif %}
          {% set isEvenWeek = (states('sensor.weeks_since_epoch') | int) % 2 == 0 %}
          {%- if (evenWeekPickup and isEvenWeek) or (not evenWeekPickup and not isEvenWeek) -%}
            yes
          {%- else -%}
            no
          {%- endif -%}

## Sensor to determine if the trash reminder should be shown
  - platform: template
    sensors:
      show_trash_reminder:
        ## If today is trash day and its before 10 AM or tomorrow is trash day and its after 2 PM
        value_template: >-
          {% set readTimeToTriggerUpdates = states('sensor.time') %}
          {% if is_state("sensor.trash_day", "yes") and as_timestamp(now()) | timestamp_custom('%H', true) | int < 10  -%}
            yes
          {%- elif is_state("sensor.trash_day_tomorrow", "yes") and as_timestamp(now()) | timestamp_custom('%H', true) | int > 14 -%}
            yes
          {%- else -%}
            no
          {%- endif %}
